tinyMCEPopup.requireLangPack();
var neoyoutube_view_count = 30;
var neoyoutube_search_cond = {};

function init() {
    tinyMCEPopup.resizeToInnerSize();

    // 閉じる
    j$('.close').click(function(){
        tinyMCEPopup.close();
    });

    // 検索
    j$('#id_search').click(function(){
        searchNew({'keyword': j$('#keyword').val()});
    });

    // Entryキーのハンドリング
    j$('input').keypress(function(e) {
        if (e.which == 13) {
            searchNew({'keyword': j$('#keyword').val()});
            return false;
        }
    });
}

function searchNew(cond) {

    // キーワード
    if (j$('#keyword').val().length < 1) {
        displayMsg('nokey');
        return;
    }

    searchVideo({'keyword':cond.keyword,
                 'page':1,
                 'orderby':'relevance',
                 'fromHistory':false});
}

function searchHistory(cond) {

    // 検索条件の復元
    cond.keyword = neoyoutube_search_cond.keyword;
    j$('#keyword').val(cond.keyword);

    searchVideo(j$.extend({}, neoyoutube_search_cond, cond, {'fromHistory': true}));
}

function searchVideo(cond) {

    var ed = tinyMCEPopup.editor;

    if (cond == null) {
        return;
    }
    else {
        if (cond.keyword == null) {
            cond.keyword = '';
        }
        j$('#no_videos').hide();
    }

    var index = (cond.page-1)*neoyoutube_view_count+1;

    // 画面表示を変更
    j$("html, body").scrollTop(0);
    j$('#id_loading').show();

    j$.extend(neoyoutube_search_cond, cond);

    j$.ajax({
        timeout: 30000,
        dataType: 'jsonp',
        data: {
/*----START DNB720_0064
            'vq': cond.keyword,
*/
            'q': cond.keyword,
//----END DNB720_0064
            'orderby': cond.orderby,
            'start-index': index,
            'max-results': neoyoutube_view_count,
/*----START DNB720_0064
            'alt':'json-in-script'
*/
            'alt':'json-in-script',
            'v':'2',
            'format':'5'
//----END DNB720_0064
        },
        url: 'http://gdata.youtube.com/feeds/api/videos',
        success: function (data) {

            j$('#id_videos').empty();

            if (parseInt(data.feed.openSearch$totalResults.$t,10) == 0) {
                j$('#view').hide();
                j$('#no_videos').show();
                return;
            }

            j$.each(data.feed.entry, function(i,item) {
                var group = item.media$group;
/*----START DNB720_0064
                var sUrl = group.media$player[0].url;
*/
                var sUrl = 'http://www.youtube.com/v/' + group.yt$videoid.$t;
//----END DNB720_0064

                j$('<div/>').addClass('thumbnail')
                  .append(j$('<a/>')
                    .attr('rel', 'vidbox')
                    .attr('href', sUrl)
                    .attr('title', item.title.$t)
                    .append(j$('<img />')
                        .attr('src', group.media$thumbnail[0].url)
                        .attr('width', '130')
                        .attr('height', '97')))
                  .append(j$('<br/>'))
                  .append(j$('<div/>')
                      .attr('class', 'thumbnail_title')
                      .append(j$('<a/>')
                        .attr('rel', 'vidbox')
                        .attr('href', sUrl)
                        .attr('title', item.title.$t)
                        .append(item.title.$t)))
                  .append(j$('<br/>'))
                  .append(j$('<input/>')
                    .attr('type', 'button')
                    .attr('value',ed.getLang('neoyoutube_dlg.large'))
                    .attr('class','btn_size')
                    .click(function() { insertTag(sUrl, 'l'); }))
                  .append(j$('<input/>')
                    .attr('type', 'button')
                    .attr('value',ed.getLang('neoyoutube_dlg.medium'))
                    .attr('class','btn_size')
                    .click(function() { insertTag(sUrl, 'm'); }))
                  .append(j$('<input/>')
                    .attr('type', 'button')
                    .attr('value',ed.getLang('neoyoutube_dlg.small'))
                    .attr('class','btn_size')
                    .click(function() { insertTag(sUrl, 's'); }))
                  .append(j$('<br/>'))
                  .appendTo('#id_videos');

            });

            // preview設定
            Videobox.init();

            // pager
            var iLen = Math.ceil(parseInt(data.feed.openSearch$totalResults.$t,10) / neoyoutube_view_count);

            // メッセージを初期化
            j$('#no_videos').hide();
            j$('#no_videos_text').empty();

            // 一覧
            j$('.pager-container').neoPager({
                                current: neoyoutube_search_cond.page,
                                length: iLen,
                                messages: {
                                    'prev': '<< 前の30件',
                                    'paging': '$page$',
                                    'next': '次の30件 >>'
                                },
                                onclick: function(event, page) {
                                        searchHistory({'page': page});
                                    }
                                });
            j$('#id_videos').show();
            j$('.pager-container').show();
            j$('#id_list_videos').show();

            j$('#id_loading').hide();
        }
    });
}

function displayMsg(error) {
    var ed = tinyMCEPopup.editor;
    var msg = ed.getLang('neoyoutube_dlg.msg_no_videos');

    if (error == 'nokey') {
        // キーワードなし
        msg = ed.getLang('neoyoutube_dlg.msg_no_key');
    }

    j$('#id_videos').empty();
    j$('.pager-container').empty();

    j$('#id_videos').hide();
    j$('.pager-container').hide();

    j$('#no_videos_text').html(msg);
    j$('#id_list_videos').hide();
    j$('#no_videos').show();

    j$('#id_loading').hide();
}


function insertTag(sUrl, sSize) {
    var ed = tinyMCEPopup.editor;

/*----START DNB720_0064
    var src = sUrl.replace('&feature=youtube_gdata', '');
    src = src.replace('watch\?v=','v/');
    src = src.replace('\?v=','v/');
----END DNB720_0064 */
    var arSize = {
        l:{width:'425', height:'350'},
        m:{width:'320', height:'264'},
        s:{width:'200', height:'165'}
    };
    var sWidth  = arSize[sSize].width;
    var sHeight = arSize[sSize].height;

/*----START DNB720_0064
    var sTitle = "src:'" + src
*/
    var sTitle = "src:'" + sUrl
//----END DNB720_0064
                + "', width:'" + sWidth
                + "', height:'" + sHeight + "'";

    var h = '<img src="' + tinyMCEPopup.getWindowArg("plugin_url") + '/../media/img/trans.gif"';
    h += ' class="mceItemFlash"';
    h += ' title="' + sTitle + '"';
    h += ' width="' + sWidth + '"';
    h += ' height="' + sHeight + '"';
    h += ' align=""';
    h += ' />';

    ed.execCommand('mceInsertContent', false, h);

    tinyMCEPopup.close();
}

tinyMCEPopup.onInit.add(init);
